#!/usr/bin/python
# -*- coding: utf-8 -*-

#descriptivo.py Operación descriptivo

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez
#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
from qt import *
from rpy import *
from Driza.widgets import wopciones

def funcion(dato,variable,cosa,opciones):  # Cambiar cosa por caso
	diccionario={}
	media=None
	varianza=None
	desviacion=None
	mediana=None
	lista=[int(x) for x in dato[variable]]
	if opciones.has_key("Media"):
		diccionario["media"]=r.mean(lista)
	if opciones.has_key("Varianza"):
		diccionario["varianza"]=r.var(lista)
	if opciones.has_key(u"Desviación"):
		diccionario["desviacion"]=r.sd(lista)
	if opciones.has_key("Mediana"):
		diccionario["mediana"]=r.median(lista)
	return diccionario

def initresultado(resultado,opciones):
	"""Inicializa al objeto resultado, añadiendole lo que crea conveniente"""
	resultado.addTabla("resultado")
	resultado["resultado"].titulo="Descriptivo"
	lista=[]
	if opciones.has_key("Media"):
		lista.append("Media")
	if opciones.has_key("Varianza"):
		lista.append("Varianza")
	if opciones.has_key(u"desviación"):
		lista.append(u"Desviación")
	if opciones.has_key("Mediana"):
		lista.append("Mediana")

	resultado["resultado"].settitulo(lista)


def interfazresultado(resultado,variable,caso,diccionario):
	"""Este método dice como introducir los datos en la tabla"""
	lista=[]
	if diccionario.has_key("media"):
		lista.append(diccionario["media"])
	if diccionario.has_key("varianza"):
		lista.append(diccionario["varianza"])
	if diccionario.has_key("desviacion"):
		lista.append(diccionario["desviacion"])
	if diccionario.has_key("mediana"):
		lista.append(diccionario["mediana"])

	resultado["resultado"].set(variable,caso,lista)

opciones=wopciones.WOpciones()
opciones.addSMB("Tipo","Media","Varianza",u"Desviación","Mediana")
widget={"tipo":"CalculoSimple","opciones":opciones}



